set tez.queue.name=${TEZ_QUEUE}; 
truncate table ${DBNAME_WRK_PROD}.f_tr_contenido_detallada_prev;

-- Creo dos tabla (fija y movil) con los registros cuyos nombre_extractor_tx no aparecen en la lista de los archivos cargados(la tabla anterior) y tambien creo el campo r_number para especificar numerar los registros por ocurrencias.

DROP TABLE IF EXISTS ${DBNAME_WRK_PROD}.altamira_trafico_icv_v91_movil_fp_temp;
CREATE TABLE ${DBNAME_WRK_PROD}.altamira_trafico_icv_v91_movil_fp_temp AS SELECT
 t0.ani_cd , 
 t0.fecha_llamada_fh ,
 t0.tipo_llamada_cd ,
 t0.costo_llamada_euro_mo ,
 t0.importe_inicial_mo , 
 t0.importe_abono_mo , 
 t0.importe_recarga_mo , 
 t0.importe_promocion_mo , 
 t0.importe_bolsa5_mo ,
 t0.importe_bolsa6_mo ,
 t0.importe_no_cargado_mo ,
 t0.importe_iva_mo , 
 t0.ani_destino_cd , 
 t0.fecha_llamada_fe , 
 t0.fecha_llamada_hr , 
 t0.duracion_llamada_mo ,
 t0.tecnologia_cd ,
 t0.impuesto_categoria_mo ,
 t0.identificador_proveedor_srv_cd , 
 t0.identificador_contenido_cd , 
 t0.identificador_tip_contenido_cd , 
 t0.cid_cd , 
 t0.deuda_mo , 
 t0.nombre_extractor_tx ,
ROW_NUMBER() over (PARTITION BY 
 t0.ani_cd , 
 t0.fecha_llamada_fh ,
 t0.tipo_llamada_cd ,
 t0.costo_llamada_euro_mo ,
 t0.importe_inicial_mo , 
 t0.importe_abono_mo , 
 t0.importe_recarga_mo , 
 t0.importe_promocion_mo , 
 t0.importe_bolsa5_mo ,
 t0.importe_bolsa6_mo ,
 t0.importe_no_cargado_mo ,
 t0.importe_iva_mo , 
 t0.ani_destino_cd , 
 t0.fecha_llamada_fe , 
 t0.fecha_llamada_hr , 
 t0.duracion_llamada_mo ,
 t0.tecnologia_cd ,
 t0.impuesto_categoria_mo ,
 t0.identificador_proveedor_srv_cd , 
 t0.identificador_contenido_cd , 
 t0.identificador_tip_contenido_cd , 
 t0.cid_cd , 
 t0.deuda_mo , 
 t0.nombre_extractor_tx) as r_number
FROM trafico.altamira_trafico_icv_v91_movil_fp t0 
LEFT JOIN ${DBNAME_EDW_PROD_LOG}.dimensional_list_nombre_extractor t1 on t0.nombre_extractor_tx = t1.nombre_extractor_tx and mode_name ='contenido' 
WHERE t1.nombre_extractor_tx IS NULL and fecha = ${CURRENT_DATE_N};

DROP TABLE IF EXISTS ${DBNAME_WRK_PROD}.altamira_trafico_icv_v91_fija_fp_temp;
create table ${DBNAME_WRK_PROD}.altamira_trafico_icv_v91_fija_fp_temp as select
 t0.ani_cd , 
 t0.fecha_llamada_fh ,
 t0.tipo_llamada_cd ,
 t0.costo_llamada_euro_mo ,
 t0.importe_inicial_mo , 
 t0.importe_abono_mo , 
 t0.importe_recarga_mo , 
 t0.importe_promocion_mo , 
 t0.importe_bolsa5_mo ,
 t0.importe_bolsa6_mo ,
 t0.importe_no_cargado_mo ,
 t0.importe_iva_mo , 
 t0.ani_destino_cd , 
 t0.fecha_llamada_fe , 
 t0.fecha_llamada_hr , 
 t0.duracion_llamada_mo ,
 t0.tecnologia_cd ,
 t0.impuesto_categoria_mo ,
 t0.identificador_proveedor_srv_cd , 
 t0.identificador_contenido_cd , 
 t0.identificador_tip_contenido_cd , 
 t0.cid_cd , 
 t0.deuda_mo , 
 t0.nombre_extractor_tx ,
ROW_NUMBER() over (PARTITION BY 
 t0.ani_cd , 
 t0.fecha_llamada_fh ,
 t0.tipo_llamada_cd ,
 t0.costo_llamada_euro_mo ,
 t0.importe_inicial_mo , 
 t0.importe_abono_mo , 
 t0.importe_recarga_mo , 
 t0.importe_promocion_mo , 
 t0.importe_bolsa5_mo ,
 t0.importe_bolsa6_mo ,
 t0.importe_no_cargado_mo ,
 t0.importe_iva_mo , 
 t0.ani_destino_cd , 
 t0.fecha_llamada_fe , 
 t0.fecha_llamada_hr , 
 t0.duracion_llamada_mo ,
 t0.tecnologia_cd ,
 t0.impuesto_categoria_mo ,
 t0.identificador_proveedor_srv_cd , 
 t0.identificador_contenido_cd , 
 t0.identificador_tip_contenido_cd , 
 t0.cid_cd , 
 t0.deuda_mo , 
 t0.nombre_extractor_tx) as r_number
FROM trafico.altamira_trafico_icv_v91_fija_fp t0
LEFT JOIN ${DBNAME_EDW_PROD_LOG}.dimensional_list_nombre_extractor t1 on t0.nombre_extractor_tx = t1.nombre_extractor_tx and mode_name ='contenido' 
WHERE t1.nombre_extractor_tx IS NULL and fecha = ${CURRENT_DATE_N};


---insert  
insert into ${DBNAME_WRK_PROD}.f_tr_contenido_detallada_prev
select
ani_cd as ani_destino_cd,
fecha_llamada_fh as fecha_mensaje_contenido_fh,
tipo_llamada_cd,
case when costo_llamada_euro_mo is not null then costo_llamada_euro_mo else 0 end costo_llamada_euro_mo,
case when importe_inicial_mo is not null then importe_inicial_mo else 0 end importe_inicial_mo,
case when importe_abono_mo is not null then importe_abono_mo else 0 end importe_abono_mo,
case when importe_recarga_mo is not null then importe_recarga_mo else 0 end importe_recarga_mo,
case when importe_promocion_mo is not null then importe_promocion_mo else 0 end importe_promocion_mo,
case when importe_bolsa5_mo is not null then importe_bolsa5_mo else 0 end importe_bolsa5_mo,
case when importe_bolsa6_mo is not null then importe_bolsa6_mo else 0 end importe_bolsa6_mo,
case when importe_no_cargado_mo is not null then importe_no_cargado_mo else 0 end importe_no_cargado_mo,
case when importe_iva_mo is not null then importe_iva_mo else 0 end importe_iva_mo,
ani_destino_cd as ani_origen_cd,
cast(to_date(from_unixtime(UNIX_TIMESTAMP(fecha_llamada_fe,'yyyyMMdd'))) as date) as fecha_llamada_fe,
fecha_llamada_hr,
case when duracion_llamada_mo is not null then duracion_llamada_mo else 0 end duracion_llamada_mo,
tecnologia_cd,
case when impuesto_categoria_mo is not null then impuesto_categoria_mo else 0 end impuesto_categoria_mo,
cast(identificador_proveedor_srv_cd as string) as proveedor_servicio_original_cd,
cast(identificador_contenido_cd as string) as contenido_original_cd,
cast(identificador_tip_contenido_cd as string) as tipo_contenido_original_cd,
cid_cd,
case when deuda_mo is not null then deuda_mo else 0 end deuda_mo,
nombre_extractor_tx as nombre_archivo_de,
CAST(from_unixtime(UNIX_TIMESTAMP(fecha_llamada_fh,'yyyy-MM-dd HH:mm:s'),'yyyyMM') as int) anio_mes_nr,
-1 as operadora_origen_id,
1 as movil_fl,
cast(to_date(from_unixtime(UNIX_TIMESTAMP(fecha_llamada_fe,'yyyyMMdd'))) as date) as fecha_inicio_mensaje_id
from ${DBNAME_WRK_PROD}.altamira_trafico_icv_v91_movil_fp_temp
where r_number = 1 

union all

select
ani_cd as ani_destino_cd,
fecha_llamada_fh as fecha_mensaje_contenido_fh,
tipo_llamada_cd,
case when costo_llamada_euro_mo is not null then costo_llamada_euro_mo else 0 end costo_llamada_euro_mo,
case when importe_inicial_mo is not null then importe_inicial_mo else 0 end importe_inicial_mo,
case when importe_abono_mo is not null then importe_abono_mo else 0 end importe_abono_mo,
case when importe_recarga_mo is not null then importe_recarga_mo else 0 end importe_recarga_mo,
case when importe_promocion_mo is not null then importe_promocion_mo else 0 end importe_promocion_mo,
case when importe_bolsa5_mo is not null then importe_bolsa5_mo else 0 end importe_bolsa5_mo,
case when importe_bolsa6_mo is not null then importe_bolsa6_mo else 0 end importe_bolsa6_mo,
case when importe_no_cargado_mo is not null then importe_no_cargado_mo else 0 end importe_no_cargado_mo,
case when importe_iva_mo is not null then importe_iva_mo else 0 end importe_iva_mo,
ani_destino_cd as ani_origen_cd,
cast(to_date(from_unixtime(UNIX_TIMESTAMP(fecha_llamada_fe,'yyyyMMdd'))) as date) as fecha_llamada_fe,
fecha_llamada_hr,
case when duracion_llamada_mo is not null then duracion_llamada_mo else 0 end duracion_llamada_mo,
tecnologia_cd,
case when impuesto_categoria_mo is not null then impuesto_categoria_mo else 0 end impuesto_categoria_mo,
cast(identificador_proveedor_srv_cd as string) as proveedor_servicio_original_cd,
cast(identificador_contenido_cd as string) as contenido_original_cd,
cast(identificador_tip_contenido_cd as string) as tipo_contenido_original_cd,
cid_cd,
case when deuda_mo is not null then deuda_mo else 0 end deuda_mo,
nombre_extractor_tx as nombre_archivo_de,
CAST(from_unixtime(UNIX_TIMESTAMP(fecha_llamada_fh,'yyyy-MM-dd HH:mm:s'),'yyyyMM') as int) anio_mes_nr,
-1 as operadora_origen_id,
2 as movil_fl,
cast(to_date(from_unixtime(UNIX_TIMESTAMP(fecha_llamada_fe,'yyyyMMdd'))) as date) as fecha_inicio_mensaje_id
from ${DBNAME_WRK_PROD}.altamira_trafico_icv_v91_fija_fp_temp
where r_number = 1 

union all

select 
ani_destino_cd,
fecha_mensaje_contenido_fh,
tipo_llamada_cd,
costo_llamada_euro_mo,
importe_inicial_mo,
importe_abono_mo,
importe_recarga_mo,
importe_promocion_mo,
importe_bolsa5_mo,
importe_bolsa6_mo,
importe_no_cargado_mo,
importe_iva_mo,
ani_origen_cd,
fecha_llamada_fe,
fecha_llamada_hr,
duracion_llamada_mo,
tecnologia_cd,
impuesto_categoria_mo,
proveedor_servicio_original_cd,
contenido_original_cd,
tipo_contenido_original_cd,
cid_cd,
deuda_mo,
nombre_archivo_de,
anio_mes_nr,
operadora_origen_id,
movil_fl,
fecha_inicio_mensaje_id
from ${DBNAME_EDW}.f_tr_contenido_detallada_reinyect;
